/*
** Copyright (C) 2003 The Free Software Foundation.
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/

#ifndef INCLUDED_DIALOGGOTOREFERENCE_H
#define INCLUDED_DIALOGGOTOREFERENCE_H

#include <glib.h>
#include <gtk/gtk.h>


class GotoReferenceDialog
{
public:
  GotoReferenceDialog (const string & currentbook, const string & currentchapter, const string & currentverse);
  virtual ~GotoReferenceDialog ();
  virtual int run();
  bool newreference;
  string newbook;
  string newchapter;
  string newverse;
protected:
  GtkWidget *gotoreferencedialog;
  GtkWidget *dialog_vbox1;
  GtkWidget *hbox1;
  GtkWidget *label1;
  GtkWidget *entry1;
  GtkWidget *dialog_action_area1;
  GtkWidget *cancelbutton1;
  GtkWidget *okbutton1;
  vector <string> input;
  virtual void show_bad_reference ();
private:
  string oldbook;
  string oldchapter;
  string oldverse;
  virtual void on_jump();
  static void on_okbutton1_clicked (GtkButton *button, gpointer user_data);
};


#endif
