/*
** Copyright (C) 2003 The Free Software Foundation.
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/

#ifndef INCLUDED_DIALOGIMPORT_NOTES_H
#define INCLUDED_DIALOGIMPORT_NOTES_H

#include <gtk/gtk.h>
#include <set>
#include "ustring.h"


class ImportNotesDialog
{
public:
  ImportNotesDialog (int dummy);
  virtual ~ ImportNotesDialog ();
  virtual int run ();
protected:
  GtkWidget *importnotesdialog;
  GtkWidget *dialog_vbox1;
  GtkWidget *vbox1;
  GtkWidget *notebook;
  GtkWidget *vbox4;
  GtkWidget *label13;
  GtkWidget *label1;
  GtkWidget *vbox2;
  GtkWidget *label6;
  GtkWidget *select_directory_button;
  GtkWidget *alignment1;
  GtkWidget *hbox2;
  GtkWidget *image1;
  GtkWidget *label8;
  GtkWidget *xml_file_label;
  GtkWidget *label4;
  GtkWidget *vbox5;
  GtkWidget *label18;
  GtkWidget *label15;
  GtkWidget *vbox6;
  GtkWidget *label19;
  GtkWidget *label14;
  GtkWidget *vbox9;
  GtkWidget *label24;
  GtkWidget *combo_startelement;
  GtkWidget *combo_entry_startelement;
  GtkWidget *label2;
  GtkWidget *table1;
  GtkWidget *label25;
  GtkWidget *label26;
  GtkWidget *label27;
  GtkWidget *label29;
  GtkWidget *label30;
  GtkWidget *label31;
  GtkWidget *label32;
  GtkWidget *label33;
  GtkWidget *combo_refs;
  GtkWidget *combo_entry_refs;
  GtkWidget *combo_text;
  GtkWidget *combo_entry_text;
  GtkWidget *combo_referred;
  GtkWidget *combo_entry_referred;
  GtkWidget *combo_project;
  GtkWidget *combo_entry_project;
  GtkWidget *combo_datemodified;
  GtkWidget *combo_entry_datemodified;
  GtkWidget *combo_datecreated;
  GtkWidget *combo_entry_datecreated;
  GtkWidget *combo_createdby;
  GtkWidget *combo_entry_createdby;
  GtkWidget *label16;
  GtkWidget *vbox8;
  GtkWidget *label23;
  GtkWidget *label22;
  GtkWidget *hbox1;
  GtkWidget *backbutton;
  GtkWidget *forwardbutton;
  GtkWidget *dialog_action_area1;
  GtkWidget *cancelbutton;
  GtkWidget *applybutton;
private:
  string file_to_import;
  set <string> elements_temp;
  vector <string> available_elements; // The different elements in the xml file.
  virtual void set_gui ();
  virtual void select_file_page ();
  virtual void unicode_page ();
  virtual void make_known_corrections_to_xml_file ();
  virtual void dig_up_all_elements ();
  virtual void begin_end_elements_page ();
  virtual void content_elements_page ();
  virtual void final_page ();
  static void on_backbutton_clicked (GtkButton * button, gpointer user_data);
  virtual void on_backbutton ();
  static void on_forwardbutton_clicked (GtkButton * button, gpointer user_data);
  virtual void on_forwardbutton ();
  static void on_applybutton_clicked (GtkButton * button, gpointer user_data);
  static void on_select_file_button_clicked (GtkButton * button, gpointer user_data);
  virtual void on_select_file_button ();
  virtual void on_apply ();
  static void start_element_handler1 (GMarkupParseContext *context,
                                      const gchar         *element_name,
                                      const gchar        **attribute_names,
                                      const gchar        **attribute_values,
                                      gpointer             user_data,
                                      GError             **error);
  static void start_element_handler2 (GMarkupParseContext *context,
                                      const gchar         *element_name,
                                      const gchar        **attribute_names,
                                      const gchar        **attribute_values,
                                      gpointer             user_data,
                                      GError             **error);
  virtual void start_element_handler2 (const string& element_name);
  static void end_element_handler1   (GMarkupParseContext *context,
                                      const gchar         *element_name,
                                      gpointer             user_data,
                                      GError             **error);
  static void end_element_handler2   (GMarkupParseContext *context,
                                      const gchar         *element_name,
                                      gpointer             user_data,
                                      GError             **error);
  virtual void end_element_handler2   (const string& element_name);
  static void text_handler1          (GMarkupParseContext *context,
                                      const gchar         *text,
                                      gsize                text_len,
                                      gpointer             user_data,
                                      GError             **error);
  static void text_handler2          (GMarkupParseContext *context,
                                      const gchar         *text,
                                      gsize                text_len,
                                      gpointer             user_data,
                                      GError             **error);
  virtual void text_handler2          (const ustring& text);
  static void passthrough_handler    (GMarkupParseContext *context,
                                      const gchar         *passthrough_text,
                                      gsize                text_len,
                                      gpointer             user_data,
                                      GError             **error);
  static void error_handler          (GMarkupParseContext *context,
                                      GError              *error,
                                      gpointer             user_data);
  // List of which elements are for what.
  string note_element;
  string reference_element;
  string notetext_element;
  string referredto_element;
  string project_element;
  string datemodified_element;
  string datecreated_element;
  string createdby_element;
  // Places to store data for gather together data for importing a new note.
  ustring reference_content;
  ustring notetext_content;
  ustring status_content;
  ustring referredto_content;
  ustring project_content;
  ustring datemodified_content;
  ustring datecreated_content;
  ustring createdby_content;
  // Some household data.
  string current_element;
  int depth;
  int depth_of_notetext;

};


#endif
