/*
** Copyright (C) 2003 The Free Software Foundation.
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/

#ifndef INCLUDED_DIALOGPRINTPROJECT_H
#define INCLUDED_DIALOGPRINTPROJECT_H

#include <gtk/gtk.h>
#include "scripture.h"
#include "ustring.h"


class PrintProjectDialog
{
public:
  PrintProjectDialog (Scripture *scripture_in, const string& projectname);
  virtual ~PrintProjectDialog ();
  virtual int run ();
protected:
private:
  GtkWidget *dialogprintproject;
  GtkWidget *dialog_vbox1;
  GtkWidget *vbox1;
  GtkWidget *label1;
  GtkWidget *progressbar1;
  GtkWidget *dialog_action_area1;
  Scripture *scripture;
  string project_name;
  static gboolean delete_event (GtkWidget * widget, GdkEvent * event, gpointer data);
  void on_delete_event ();
  bool dialog_is_about_to_be_deleted;
  guint event_source_id1;
  guint event_source_id2;
  static bool on_update_display_timeout (gpointer data);
  bool update_display ();
  double percentage;
  static void printreferencesdialog_convert (gpointer data);
  virtual void convert ();
  static bool on_close_timeout (gpointer data);
  bool on_close ();
};


#endif
