/*
** Copyright (C) 2003 The Free Software Foundation.
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/


#include "utilities.h"
#include "dialogprogress.h"
#include <glib.h>


ProgressDialog::ProgressDialog (bool *ready, double *percentage)
{
  myready = ready;
  mypercentage = percentage;

  progressdialog = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (progressdialog), "Progress");
  gtk_window_set_position (GTK_WINDOW (progressdialog), GTK_WIN_POS_CENTER_ON_PARENT);
  gtk_window_set_modal (GTK_WINDOW (progressdialog), TRUE);
  // It is made a splash screen so that the user cannot delete the window so
  // crashing the application.
  gtk_window_set_type_hint (GTK_WINDOW (progressdialog), GDK_WINDOW_TYPE_HINT_SPLASHSCREEN);

  dialog_vbox1 = GTK_DIALOG (progressdialog)->vbox;
  gtk_widget_show (dialog_vbox1);

  label1 = gtk_label_new ("Progress ...");
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), label1, FALSE, FALSE, 0);

  progressbar1 = gtk_progress_bar_new ();
  gtk_widget_show (progressbar1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), progressbar1, FALSE, FALSE, 0);
  gtk_widget_set_size_request (progressbar1, 300, -1);

  dialog_action_area1 = GTK_DIALOG (progressdialog)->action_area;
  gtk_widget_show (dialog_action_area1);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);
  
  g_timeout_add (20, GSourceFunc (progressdialog_on_timeout), gpointer(this));
}


ProgressDialog::~ProgressDialog ()
{
  gtk_widget_destroy (progressdialog);
}


int ProgressDialog::run()
{
  return gtk_dialog_run (GTK_DIALOG (progressdialog));
}


bool ProgressDialog::set_gui()
{
  gtk_progress_bar_set_fraction (GTK_PROGRESS_BAR (progressbar1), *mypercentage);
  if (*myready)
    gtk_dialog_response (GTK_DIALOG (progressdialog), GTK_RESPONSE_NONE);
  return !(*myready);
}


bool ProgressDialog::progressdialog_on_timeout (gpointer data)
{
  return ((ProgressDialog *) data)->set_gui();
}
