/*
** Copyright (C) 2003 The Free Software Foundation.
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/

#ifndef INCLUDED_DIALOGSEARCHSPECIAL_H
#define INCLUDED_DIALOGSEARCHSPECIAL_H


#include <gtk/gtk.h>
#include "configuration.h"


class SearchSpecialDialog
{
public:
  SearchSpecialDialog (Configuration * configuration, GtkListStore * liststore);
  virtual ~ SearchSpecialDialog ();
  virtual int run ();
  vector < string > results;
  bool is_indexing;
protected:
private:
  GtkWidget *searchspecialdialog;
  GtkWidget *dialog_vbox1;
  GtkWidget *notebook1;
  GtkWidget *vbox1;
  GtkWidget *label2;
  GtkWidget *word_per_verse_info_label;
  GtkWidget *hbox1;
  GtkWidget *label4;
  GtkWidget *word_per_verse_entry;
  GtkWidget *vbox2;
  GtkWidget *radiobutton1;
  GSList *radiobutton1_group;
  GtkWidget *radiobutton2;
  GtkWidget *word_per_verse_checkbutton;
  GtkWidget *word_per_verse_info_label2;
  GtkWidget *label1;
  GtkWidget *dialog_action_area1;
  GtkWidget *cancelbutton;
  GtkWidget *findbutton;
  string mydatabase;
  Configuration *myconfiguration;
  bool thread_is_ready;
  double percentage;
  void on_buttonfind_clicked ();
  void on_buttonfind_clicked_execute ();
  vector < string > inputrefs;
  void set_gui ();
  static void searchspecialdialog_on_notebook1_change_current_page (GtkNotebook * notebook, gint offset,                                                      gpointer user_data);
  static void searchspecialdialog_on_word_per_verse_entry_changed (GtkEditable * editable, gpointer user_data);
  static void searchspecialdialog_on_findbutton_clicked (GtkButton * button, gpointer user_data);
  static void searchspecialdialog_on_buttonfind_clicked_execute (gpointer data);
};


#endif
