/*
** Copyright (C) 2003 The Free Software Foundation.
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/

#ifndef INCLUDED_DIALOGUNICODE_H
#define INCLUDED_DIALOGUNICODE_H


#include <gtk/gtk.h>


class UnicodeDialog
{
public:
  UnicodeDialog (const string & filetoconvert);
  virtual ~ UnicodeDialog ();
  virtual int run ();
protected:
  GtkWidget * unicodedialog;
  GtkWidget *dialog_vbox1;
  GtkWidget *label1;
  GtkWidget *vbox1;
  GtkWidget *combo1;
  GtkWidget *combo_entry1;
  GtkWidget *progressbar1;
  GtkWidget *scrolledwindow1;
  GtkWidget *textview1;
  GtkWidget *dialog_action_area1;
  GtkWidget *okbutton1;
private:
  vector < string > possible_encodings;
  vector < string > working_encodings;
  unsigned int current_encoding;
  string filename;
  static void unicodedialog_on_combo_entry1_changed (GtkEditable * editable, gpointer user_data);
  virtual void on_combo_changed ();
  static void unicodedialog_on_okbutton1_clicked (GtkButton * button, gpointer user_data);
  virtual void on_ok ();
  static bool unicodedialog_filter_encodings (gpointer data);
  bool filter_encodings ();
  static void unicodedialog_thread_filter_encodings (gpointer data);
  virtual void thread_filter_encodings ();
  guint event_source_id;
  static gboolean delete_event (GtkWidget * widget, GdkEvent * event, gpointer data);
};


#endif
