 /*
  ** Copyright (C) 2003 The Free Software Foundation.
  **  
  ** This program is free software; you can redistribute it and/or modify
  ** it under the terms of the GNU General Public License as published by
  ** the Free Software Foundation; either version 2 of the License, or
  ** (at your option) any later version.
  **  
  ** This program is distributed in the hope that it will be useful,
  ** but WITHOUT ANY WARRANTY; without even the implied warranty of
  ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ** GNU General Public License for more details.
  **  
  ** You should have received a copy of the GNU General Public License
  ** along with this program; if not, write to the Free Software
  ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  **  
  */


#include "libraries.h"
#include "directories.h"
#include <libgen.h>
#include <glib.h>
#include <config.h>
#include "constants.h"
#include "utilities.h"


void
directories_check_structure ()
{
  string command;
  // Check and/or create the root directory of all data.
  command = "mkdir -p '" + directories_get_root () + "'";
  system (command.c_str ());
  // This first one cannot yet use create_directory, because that
  // function needs the directory we are now creating...
  // But all next functions can use create_directory.
  // Check and/or create the projects directory.
  create_directory (directories_get_projects ());
  create_directory (directories_get_references ());
  create_directory (directories_get_notes ());
}


string directories_get_root ()
{
  // This returns the root of all data, usually <home>.bibledit
  return g_build_filename (g_get_home_dir(), ".bibledit", NULL);
}


string directories_get_projects ()
{
  // This returns the directory with all the projects.
  return g_build_filename (directories_get_root ().c_str(), "projects", NULL);
}


string directories_get_references ()
{
  // This returns the directory with the references
  return g_build_filename (directories_get_root ().c_str(), "references", NULL);
}


string directories_get_notes ()
{
  // This returns the directory with the notes
  return g_build_filename (directories_get_root ().c_str(), "notes", NULL);
}
