/*
** Copyright (C) 2003 The Free Software Foundation.
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/


#include "libraries.h"
#include "utilities.h"
#include "docbook_list.h"
#include <config.h>


DocbookList::DocbookList(const string& filename, const string& heading)
: writetext (filename)
{
  // XML header
  writetext.out << "<?xml version=\"1.0\" encoding=\"UTF8\"?>" << endl;
  // Reference to the local DTD
  writetext.out << "<!DOCTYPE book SYSTEM \"" << PACKAGE_DATA_DIR << "/docbookx.dtd\">" << endl;
  // Open the article and the list.
  writetext.out << "<article>" << endl;
  writetext.out << "<itemizedlist>" << endl;
}


DocbookList::~DocbookList()
{
  // Close list and article.
  writetext.out << "</itemizedlist>" << endl;
  writetext.out << "</article>" << endl;
}


void DocbookList::writeline (const string& line)
{
  writetext.out << "<listitem>" << endl;
  writetext.out << line << endl;
  writetext.out << "</listitem>" << endl;
}
