/*
** Copyright (C) 2003 The Free Software Foundation.
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/


#ifndef INCLUDED_HTML_BOOK_H
#define INCLUDED_HTML_BOOK_H


#include "libraries.h"
#include "utilities.h"
#include "usfm.h"


class HtmlBook
{
public:
  HtmlBook (const string& filename, const string& runningheader, 
            const string& previoustitle, const string& previouslink, 
            const string& nexttitle, const string& nextlink,
            const string& indexlink, const vector<string>& headers);
  virtual ~HtmlBook ();
  virtual void openindex ();
  virtual void closeindex ();
  virtual void writelink (const string& title, const string& link);
  virtual void openchapter (unsigned int chapternumber, const string& runningheader);
  virtual void closechapter ();
  virtual void openparagraph ();
  virtual void closeparagraph ();
  virtual void writeline (const string& line);
private:
  WriteText writetext;
  Usfm usfm;
  ustring bold_strikeout (const ustring& line);
  string myprevioustitle;
  string mypreviouslink;
  string mynexttitle;
  string mynextlink;
  string myindexlink;
  bool paragraph_opened;
};


#endif
