/*
** Copyright (C) 2003 The Free Software Foundation.
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/


#include "libraries.h"
#include "utilities.h"
#include "html_list.h"
#include <config.h>


HtmlList::HtmlList(const string& filename, const string& heading)
: writetext (filename)
{
  // Headers
  writetext.out << "<html>" << endl;
  writetext.out << "<head>" << endl;
  writetext.out << "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">" << endl;
  writetext.out << "<title>" << heading << "</title>" << endl;
  writetext.out << "<meta name=\"generator\" content=\"Bibledit\">" << endl;
  writetext.out << "</head>" << endl;
  writetext.out << "<body bgcolor=\"white\" text=\"black\" link=\"#0000FF\" vlink=\"#840084\" alink=\"#0000FF\">" << endl;
  // Start list.
  writetext.out << "<ul>" << endl;
}


HtmlList::~HtmlList()
{
  // Close list and html file.
  writetext.out << "</ul>" << endl;
  writetext.out << "</body>" << endl;
  writetext.out << "</html>" << endl;
}


void HtmlList::writeline (const string& line)
{
  writetext.out << "<li>" << endl;
  writetext.out << line << endl;
  writetext.out << "</li>" << endl;
}
