/*
** Copyright (C) 2003 The Free Software Foundation.
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/

#ifndef INCLUDED_MAINWINDOW_H
#define INCLUDED_MAINWINDOW_H


#include <gtk/gtk.h>
#include "configuration.h"
#include "track.h"
#include "book.h"
//#include "backup.h"
#include "undo.h"
#include "windowscompanion.h"
#include "scripture.h"
#include "ustring.h"


class MainWindow
{
public:
  MainWindow ();
  virtual ~ MainWindow ();
  virtual int run ();
  GtkWidget *mainwindow;
protected:
  /* IMPORTANT If more menu items are added see whether they should be made 
   * in(sensitive) depending on whether a project has been opened. */
  GtkWidget *vbox1;
  GtkWidget *menubar1;
  GtkWidget *menuitem_file;
  GtkWidget *menuitem_file_menu;
  GtkWidget *file_project;
  GtkWidget *image463;
  GtkWidget *file_project_menu;
  GtkWidget *new1;
  GtkWidget *image903;
  GtkWidget *open1;
  GtkWidget *close1;
  GtkWidget *delete1;
  GtkWidget *print_project;
  GtkWidget *image805;
  GtkWidget *properties1;
  GtkWidget *import1;
  GtkWidget *image464;
  GtkWidget *copy_project_to;
  GtkWidget *image2688;
  GtkWidget *compare_with1;
  GtkWidget *image2764;
  GtkWidget *file_references;
  GtkWidget *image465;
  GtkWidget *file_references_menu;
  GtkWidget *open_references1;
  GtkWidget *image466;
  GtkWidget *references_save_as;
  GtkWidget *print_references;
  GtkWidget *image759;
  GtkWidget *close_references;
  GtkWidget *image468;
  GtkWidget *delete_references;
  GtkWidget *image469;
  GtkWidget *notes2;
  GtkWidget *image936;
  GtkWidget *notes2_menu;
  GtkWidget *new_note;
  GtkWidget *delete_note;
  GtkWidget *image963;
  GtkWidget *import_notes;
  GtkWidget *image1455;
  GtkWidget *quit1;
  GtkWidget *menuitem_edit;
  GtkWidget *menuitem_edit_menu;
  GtkWidget *cut1;
  GtkWidget *copy1;
  GtkWidget *paste1;
  GtkWidget *separator2;
  GtkWidget *undo1;
  GtkWidget *image295;
  GtkWidget *redo1;
  GtkWidget *image296;
  GtkWidget *separator4;
  GtkWidget *find1;
  GtkWidget *find_and_replace1;
  GtkWidget *findspecial1;
  GtkWidget *image313;
  GtkWidget *find_in_notes1;
  GtkWidget *image1430;
  GtkWidget *separator7;
  GtkWidget *get_references_from_note;
  GtkWidget *image3158;
  GtkWidget *menuitem_view;
  GtkWidget *menuitem_view_menu;
  GtkWidget *font1;
  GtkWidget *separator5;
  GtkWidget *viewnotes;
  GtkWidget *image2627;
  GtkWidget *viewnotes_menu;
  GSList *view_notes_group1;
  GtkWidget *notes_for_one_verse1;
  GtkWidget *notes_for_all_verses1;
  GtkWidget *notes_edited_today1;
  GtkWidget *to_myself;
  GtkWidget *to_subteam;
  GtkWidget *to_team1;
  GtkWidget *to_panel1;
  GtkWidget *to_church1;
  GtkWidget *to_consultant1;
  GtkWidget *to_bible_society1;
  GtkWidget *separator6;
  GtkWidget *more_info_on_current_note1;
  GtkWidget *image1838;
  GtkWidget *insert1;
  GtkWidget *insert1_menu;
  GtkWidget *standard_text_1;
  GtkWidget *image1963;
  GtkWidget *standard_text_2;
  GtkWidget *image1964;
  GtkWidget *standard_text_3;
  GtkWidget *image1965;
  GtkWidget *standard_text_4;
  GtkWidget *image1966;
  GtkWidget *menuitem_goto;
  GtkWidget *menuitem_goto_menu;
  GtkWidget *next_verse1;
  GtkWidget *image95;
  GtkWidget *previous_verse1;
  GtkWidget *image96;
  GtkWidget *next_chapter1;
  GtkWidget *image97;
  GtkWidget *previous_chapter1;
  GtkWidget *image98;
  GtkWidget *next_book1;
  GtkWidget *image99;
  GtkWidget *previous_book1;
  GtkWidget *image100;
  GtkWidget *next_reference1;
  GtkWidget *image608;
  GtkWidget *previous_reference1;
  GtkWidget *image609;
  GtkWidget *reference1;
  GtkWidget *image101;
  GtkWidget *menuitem_preferences;
  GtkWidget *menuitem_preferences_menu;
  GtkWidget *bibledit_windows_companion1;
  GtkWidget *image103;
  GtkWidget *notes_preferences;
  GtkWidget *image2116;
  GtkWidget *menuitem_diagnostics;
  GtkWidget *menuitem_diagnostics_menu;
  GtkWidget *view_system_log1;
  GtkWidget *image106;
  GtkWidget *menuitem_help;
  GtkWidget *menuitem_help_menu;
  GtkWidget *help1;
  GtkWidget *about1;
  GtkWidget *image107;
  GtkWidget *toolbar1;
  GtkWidget *button_back;
  GtkWidget *image1;
  GtkWidget *button_forward;
  GtkWidget *image2;
  GtkWidget *combo_book;
  GtkWidget *combo_entry_book;
  GtkWidget *combo_chapter;
  GtkWidget *combo_entry_chapter;
  GtkWidget *combo_verse;
  GtkWidget *combo_entry_verse;
  GtkWidget *hbox1;
  GtkWidget *hpaned1;
  GtkWidget *vpaned1;
  GtkWidget *scrolledwindow1;
  GtkWidget *textview_edit;
  GtkWidget *notebook1;
  GtkWidget *scrolledwindow3;
  GtkWidget *textview_notes;
  GtkWidget *label1;
  GtkWidget *hbox3;
  GtkWidget *scrolledwindow4;
  GtkWidget *textview_note;
  GtkWidget *scrolledwindow5;
  GtkWidget *viewport1;
  GtkWidget *vbox2;
  GtkWidget *label5;
  GtkWidget *combo_ref_to;
  GtkWidget *combo_ref_to_entry;
  GtkWidget *label3;
  GtkWidget *scrolledwindow6;
  GtkWidget *textview_refs;
  GtkWidget *label6;
  GtkWidget *combo_project;
  GtkWidget *combo_project_entry;
  GtkWidget *hbox4;
  GtkWidget *button_cancel;
  GtkWidget *button_ok;
  GtkWidget *label2;
  GtkWidget *scrolledwindow2;
  GtkWidget *treeview1;
  GtkWidget *statusbar1;
  GtkAccelGroup *accel_group;
  // Gtk variables manually added.
  GtkTextBuffer *textbuffer_edit;
  GtkTextBuffer *textbuffer_notes;
  gint statusbar_context_id;
  GtkListStore *liststore;
  GtkTreeViewColumn *treecolumn;
  GtkTreeSelection *treeselect;
  GtkTextTag *editor_line_tag;

  /* Initialization */
  virtual void initialize_project ();
  virtual void enable_or_disable_widgets (bool enable);

  /* Menu callbacks */
  static void on_open1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void open ();
  static void on_close1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void close ();
  static void on_new1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void newproject ();
  static void on_properties1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void editproject ();
  static void on_delete1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void deleteproject ();
  static void on_quit1_activate (GtkMenuItem * menuitem, gpointer user_data);
  static void on_view_system_log1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void viewlog ();
  static void on_help1_activate (GtkMenuItem * menuitem, gpointer user_data);
  static void on_about1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void showabout ();
  static void on_undo1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void menu_undo ();
  static void on_redo1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void menu_redo ();
  static void on_edit1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void menu_edit ();
  static void on_find1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void menu_find ();
  static void on_find_and_replace1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void menu_replace ();
  static void on_findspecial1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void menu_findspecial ();
  static void on_bibledit_windows_companion1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void companion_settings ();
  static void on_font1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void editor_settings ();
  static void on_import1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void menu_import ();
  static gboolean on_mainwindow_delete_event (GtkWidget *widget, GdkEvent *event, gpointer user_data);
  static void on_print_project_activate (GtkMenuItem *menuitem, gpointer user_data);
  virtual void on_print_project ();
  static void on_insert1_activate (GtkMenuItem *menuitem, gpointer user_data);
  virtual void on_menu_insert ();
  static void on_notes_preferences_activate (GtkMenuItem *menuitem, gpointer user_data);
  virtual void on_notes_preferences ();
  static void on_copy_project_to_activate (GtkMenuItem *menuitem, gpointer user_data);
  virtual void on_copy_project_to ();
  static void on_compare_with1_activate (GtkMenuItem *menuitem, gpointer user_data);
  virtual void on_compare_with ();

  /* Navigation  */
  static void on_combo_entry_book_changed (GtkEditable * editable, gpointer user_data);
  virtual void on_combo_book_changed ();
  static void on_combo_entry_chapter_changed (GtkEditable * editable, gpointer user_data);
  virtual void on_combo_chapter_changed ();
  static void on_combo_entry_verse_changed (GtkEditable * editable, gpointer user_data);
  virtual void on_combo_verse_changed ();
  static void on_next_verse1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void goto_next_verse ();
  static void on_previous_verse1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void goto_previous_verse ();
  static void on_next_chapter1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void goto_next_chapter ();
  static void on_previous_chapter1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void goto_previous_chapter ();
  static void on_next_book1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void goto_next_book ();
  static void on_previous_book1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void goto_previous_book ();
  static void on_reference1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void goto_reference ();
  virtual void go_to_reference (const string & gotobook, const string & gotochapter, const string & gotoverse, bool jump, bool highlight);
  bool go_to_reference_running;
  string editor_current_book, editor_current_chapter, editor_current_verse;
  static bool mainwindow_on_navigation_timeout (gpointer data);
  virtual bool on_navigation_timeout ();
  bool driving_book, driving_chapter, driving_verse;
  static void on_textview_edit_move_cursor (GtkTextView * textview, GtkMovementStep step, gint count, gboolean extend_selection, gpointer user_data);
  static bool mainwindow_on_cursor_moved_delayed (gpointer data);
  virtual void on_cursor_moved ();
  bool focus_programmatically_being_grabbed;
  static void on_textview_edit_grab_focus (GtkWidget * widget, gpointer user_data);
  virtual void on_grab_focus ();
  string cursor_get_verse_number ();
  unsigned int on_grab_focus_timer;
  string goto_cursor_position;
  unsigned int navigation_change_timer;
  string navigator_current_book, navigator_current_chapter, navigator_current_verse;
  static bool mainwindow_on_grab_focus_delayed_handler (gpointer data);
  bool on_grab_focus_delayed_handler ();
  void highlight_verse_at_cursor ();

  /* Tracker */
  static void on_button_forward_clicked (GtkButton * button, gpointer user_data);
  virtual void goto_next_reference ();
  static void on_button_back_clicked (GtkButton * button, gpointer user_data);
  virtual void goto_previous_reference ();
  virtual void set_next_or_previous_item (GtkCombo * combo, const string & current_text, bool next);
  vector < string > combo_book_popdown_strings;
  vector < string > combo_chapter_popdown_strings;
  vector < string > combo_verse_popdown_strings;
  virtual void set_sensitivity_of_navigator_buttons ();
  static bool mainwindow_on_tracker_timeout (gpointer data);
  virtual bool on_tracker_timeout ();
  virtual void set_next_or_previous_reference (bool next);
  Track track;

  /* Variables for general use */
  Configuration *configuration;
  Scripture *scripture;
  Book *navigator_book;

  /* Loading, editing, saving */
  Book *book;
  virtual void editor_load_chapter ();
  static bool mainwindow_editor_position_cursor_at_verse (gpointer data);
  virtual bool editor_position_cursor_at_verse ();
  virtual void editor_save ();
  static bool mainwindow_on_save_timeout (gpointer data);
  virtual bool on_save_timeout ();
  virtual void editor_set_font ();

  /* Clipboard */
  static void on_cut1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void on_cut ();
  static void on_copy1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void on_copy ();
  static void on_paste1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void on_paste ();

  /* Backups */
  //  Backup backup;

  /* List store and reference handling */
  static gboolean on_treeview1_key_press_event (GtkWidget * widget, GdkEventKey * event, gpointer user_data);
  static gboolean on_treeview1_button_press_event (GtkWidget * widget, GdkEventButton * event, gpointer user_data);
  virtual void on_list_goto ();
  static void mainwindow_selection_foreach_function (GtkTreeModel * model, GtkTreePath * path, GtkTreeIter * iter, gpointer data);
  static void on_open_references1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void on_open_references ();
  string selected_reference;
  static void on_references_save_as_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void on_save_references ();
  static void on_print_references_activate (GtkMenuItem *menuitem, gpointer user_data);
  virtual void on_print_references ();
  static void on_close_references_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void on_clear_references ();
  static void on_delete_references_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void on_delete_references ();
  static void on_delete_reference (GtkTreeModel * model, GtkTreePath * path, GtkTreeIter * iter, gpointer data);
  static void on_next_reference1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void on_next_reference ();
  static void on_previous_reference1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void on_previous_reference ();
  GtkTextTag * editor_reference_tag;
  virtual void highlight_searchwords (int versenumber);
  virtual void highlight_searchwords_internal (unsigned int linenumber, unsigned int versenumber, const string & searchword, bool & cursor_set, bool & is_verse, bool casesensitive);
  vector <ustring> references_searchwords;
  vector <bool> references_casesensitives;
  bool navigator_highlight;

  /* Undo and Redo */
  Undo undo;
  static void on_textbuffer_edit_insert_text (GtkTextBuffer * textbuffer, GtkTextIter * arg1, gchar * arg2, gint arg3, gpointer user_data);
  virtual void on_insert (GtkTextBuffer * textbuffer, GtkTextIter * pos, const ustring & text, int bytes);
  static void on_textbuffer_edit_delete_text (GtkTextBuffer * textbuffer, GtkTextIter * arg1, GtkTextIter * arg2, gpointer user_data);
  virtual void on_erase (GtkTextBuffer * textbuffer, GtkTextIter * range_begin, GtkTextIter * range_end);

  /* Undo and Redo */
  static bool mainwindow_on_windows_companion_timeout (gpointer data);
  virtual bool on_windows_companion_timeout ();

  /* Bibledit Windows Companion */
  WindowsCompanion windowscompanion;

  /* Title bar and status bar */
  virtual void set_titlebar (const ustring& project);

  /* Notes editor */
  static gboolean notes_motion_notify_event (GtkWidget *text_view, GdkEventMotion *event, gpointer user_data);
  virtual gboolean on_notes_pointer_moved (GtkWidget *text_view, GdkEventMotion *event);
  virtual void set_cursor_if_appropriate (GtkTextView *text_view, gint x, gint y);
  gboolean hovering_over_link;
  GdkCursor *hand_cursor;
  GdkCursor *regular_cursor;
  static gboolean notes_visibility_notify_event (GtkWidget *text_view, GdkEventVisibility *event, gpointer user_data);
  virtual gboolean on_notes_visibility_notified (GtkWidget *text_view, GdkEventVisibility *event);
  static gboolean notes_key_press_event (GtkWidget *widget, GdkEventKey *event, gpointer user_data);
  virtual gboolean on_notes_key_press_event (GtkWidget *widget, GdkEventKey *event);
  static void notes_event_after (GtkWidget *widget, GdkEvent *event, gpointer user_data);
  virtual void on_notes_event_after (GtkWidget *text_view, GdkEvent *ev);
  virtual void notes_edit_if_link (GtkWidget *text_view, GtkTextIter *iter);
  static void on_new_note_activate (GtkMenuItem *menuitem, gpointer user_data);
  virtual void on_new_note ();
  virtual void notes_delete_if_link (GtkWidget *text_view, GtkTextIter *iter);
  static void on_delete_note_activate (GtkMenuItem *menuitem, gpointer user_data);
  virtual void on_delete_note ();
  static void on_notes_redisplay (GtkMenuItem *menuitem, gpointer user_data);
  virtual void notes_redisplay ();
  static void on_find_in_notes1_activate (GtkMenuItem *menuitem, gpointer user_data);
  virtual void find_in_notes ();
  static void on_import_notes_activate (GtkMenuItem *menuitem, gpointer user_data);
  virtual void on_import_notes ();
  static void on_button_cancel_clicked (GtkButton *button, gpointer user_data);
  virtual void on_notes_button_cancel ();
  static void on_button_ok_clicked (GtkButton *button, gpointer user_data);
  virtual void on_notes_button_ok ();
  virtual void on_notes_button_ok_cancel ();
  virtual void notes_fill_edit_screen (int id, bool newnote);
  int edit_note_id;
  GtkTextBuffer *textbuffer_references;
  GtkTextBuffer *textbuffer_note;
  unsigned int note_info_date_created;
  unsigned int note_info_date_modified;
  string note_info_user_created;
  bool note_current_date_inserted;
  GtkWidget *note_widget_focused_previously;
  static void on_combo_entry_ref_to_changed (GtkEditable *editable, gpointer user_data);
  virtual void on_referred_to_changed ();
  virtual void note_insert_date_and_text (const string& text);
  bool note_edit_filling_note_controls;
  static void on_standard_text_1_activate (GtkMenuItem *menuitem, gpointer user_data);
  static void on_standard_text_2_activate (GtkMenuItem *menuitem, gpointer user_data);
  static void on_standard_text_3_activate (GtkMenuItem *menuitem, gpointer user_data);
  static void on_standard_text_4_activate (GtkMenuItem *menuitem, gpointer user_data);
  virtual void on_insert_standard_text (GtkMenuItem *menuitem);
  static void on_more_info_on_current_note1_activate (GtkMenuItem *menuitem, gpointer user_data);
  virtual void on_more_info_on_current_note1 ();
  static void on_menuitem_view_activate (GtkMenuItem *menuitem, gpointer user_data);
  virtual void on_menuitem_view ();
  virtual void stop_displaying_more_notes ();
  static bool on_display_notes_timeout (gpointer data);
  virtual bool on_display_notes ();
  unsigned int on_display_notes_timer;
  unsigned int notes_ids_to_display_pointer;
  vector<gint> notes_ids_to_display;
  static bool on_note_display_one (gpointer data);
  virtual bool note_display_one ();
  static void on_note_editor_changed (GtkEditable * editable, gpointer user_data);
  virtual void on_note_editor_changed_2 ();
  static void on_get_references_from_note_activate (GtkMenuItem *menuitem, gpointer user_data);
  virtual void on_get_references_from_note ();
};


#endif
