/*
** Copyright (C) 2003 The Free Software Foundation.
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/


#include "libraries.h"
#include "project.h"
#include "utilities.h"
#include "config.h"
#include <glib.h>
#include "directories.h"


Project::Project (Configuration * configuration)
{
  // Read the project file, if there is any. Add the bits that are missing.
  filename = g_build_filename (directories_get_projects().c_str(), configuration->project.c_str(), "projectsettings", NULL);
  ReadText rc (filename, true);
  for (unsigned int i = 0; i <= 1000; i++) {
    switch (i) {
      case 2:
      {
        if (i < rc.lines.size ()) {
          font = rc.lines[i];
        }
        else {
          font = configuration->editor_font_name;
        }
        break;
      }
      case 3:
      {
        if (i < rc.lines.size ()) {
          language = rc.lines[i];
        }
        else
        {
          language = "English";
        }
        break;
      }
    }
  }
}


Project::~Project ()
{
  // If the object goes out of scope, it saves the project settings.
  vector < string > output;
  output.push_back (VERSION);
  output.push_back ("There is no need for editing this file, because it is maintained by bibledit");
  output.push_back (font);
  output.push_back (language);
  try
  {
    write_lines (filename, output);
  }
  catch (exception & ex)
  {
    cerr << ex.what () << endl;
  }
}
