 /*
  ** Copyright (C) 2003 The Free Software Foundation.
  **  
  ** This program is free software; you can redistribute it and/or modify
  ** it under the terms of the GNU General Public License as published by
  ** the Free Software Foundation; either version 2 of the License, or
  ** (at your option) any later version.
  **  
  ** This program is distributed in the hope that it will be useful,
  ** but WITHOUT ANY WARRANTY; without even the implied warranty of
  ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ** GNU General Public License for more details.
  **  
  ** You should have received a copy of the GNU General Public License
  ** along with this program; if not, write to the Free Software
  ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  **  
  */


#include "libraries.h"
#include "utilities.h"
#include <libgen.h>
#include <glib.h>
#include <config.h>
#include "constants.h"
#include "projectutils.h"
#include "project.h"
#include "directories.h"


void projectutils_new (Configuration * configuration)
{
  /*
     This makes a new project.
     It is named "New Project".
     This project can later be tuned to the user's wishes.
   */
  // Make the new directory.
  string directory = g_build_filename (directories_get_projects ().c_str(), NEW_PROJECT, NULL);
  create_directory (directory);
  // Produce the default settings.
  Project ps (configuration);
}


string projectutils_scripture_filename (const string & project, const string & book)
{
  return g_build_filename (directories_get_projects ().c_str(), project.c_str(), book.c_str(), "current-version", NULL);
}


void projectutils_copy_project (const ustring& project, const ustring& newproject)
// Copies "project" to "newproject.
{
  string olddirectory;
  olddirectory = g_build_filename (directories_get_projects ().c_str(), project.c_str(), NULL);
  string newdirectory;
  newdirectory = g_build_filename (directories_get_projects ().c_str(), newproject.c_str(), NULL);
  string command;
  command = "cp -r '";
  command.append (olddirectory);
  command.append ("' '");
  command.append (newdirectory);
  command.append ("'");
  system (command.c_str());
}


void projectutils_delete_project (const ustring& project)
// Deletes a project.
{
  string directory = g_build_filename (directories_get_projects ().c_str(), project.c_str(), NULL);
  string command = "rm -rf \"";
  command.append (g_strescape (directory.c_str(), NULL));
  command.append ("\"");
  system (command.c_str());
}
